scala.collection.mutable

# ListBuffer

#### final class ListBuffer[A] extends Buffer[A] with GenericTraversableTemplate[A, ListBuffer] with BufferLike[A, ListBuffer[A]] with Builder[A, List[A]] with SeqForwarder[A] with Serializable

A `Buffer` implementation back up by a list. It provides constant time prepend and append. Most other operations are linear.

A

  the type of this list buffer's elements.

Annotations
  @SerialVersionUID( uid = 3419063961353022661L )
Source
  ListBuffer.scala
Version

  2.8

Since

  1

See also

  "Scala's Collection Library overview" section on `List Buffers` for more information.

Linear Supertypes
Serializable, Serializable, SeqForwarder[A], IterableForwarder[A], TraversableForwarder[A], Builder[A, List[A]], Buffer[A], BufferLike[A, ListBuffer[A]], Subtractable[A, ListBuffer[A]], Scriptable[A], Shrinkable[A], Growable[A], Seq[A], SeqLike[A, ListBuffer[A]], Cloneable[ListBuffer[A]], Seq[A], SeqLike[A, ListBuffer[A]], GenSeq[A], GenSeqLike[A, ListBuffer[A]], PartialFunction[Int, A], (Int) ⇒ A, Iterable[A], Iterable[A], IterableLike[A, ListBuffer[A]], Equals, GenIterable[A], GenIterableLike[A, ListBuffer[A]], Traversable[A], Mutable, Traversable[A], GenTraversable[A], GenericTraversableTemplate[A, ListBuffer], TraversableLike[A, ListBuffer[A]], GenTraversableLike[A, ListBuffer[A]], Parallelizable[A, ParSeq[A]], TraversableOnce[A], GenTraversableOnce[A], FilterMonadic[A, ListBuffer[A]], HasNewBuilder[A, ListBuffer[A]], AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. ListBuffer
2. Serializable
3. Serializable
4. SeqForwarder
5. IterableForwarder
6. TraversableForwarder
7. Builder
8. Buffer
9. BufferLike
10. Subtractable
11. Scriptable
12. Shrinkable
13. Growable
14. Seq
15. SeqLike
16. Cloneable
17. Seq
18. SeqLike
19. GenSeq
20. GenSeqLike
21. PartialFunction
22. Function1
23. Iterable
24. Iterable
25. IterableLike
26. Equals
27. GenIterable
28. GenIterableLike
29. Traversable
30. Mutable
31. Traversable
32. GenTraversable
33. GenericTraversableTemplate
34. TraversableLike
35. GenTraversableLike
36. Parallelizable
37. TraversableOnce
38. GenTraversableOnce
39. FilterMonadic
40. HasNewBuilder
41. AnyRef
42. Any

Visibility

1. Public
2. All

### Instance Constructors

1. #### new ListBuffer()

### Type Members

1. #### type Self = ListBuffer[A]

   The type implementing this traversable

   The type implementing this traversable

   Attributes
     protected
   Definition Classes
     TraversableLike

2. #### class WithFilter extends FilterMonadic[A, Repr]

   A class supporting filtered operations.

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def ++(xs: GenTraversableOnce[A]): ListBuffer[A]

   Creates a new collection containing both the elements of this collection and the provided traversable object.

   Creates a new collection containing both the elements of this collection and the provided traversable object.

   xs

     the traversable object.

   returns

     a new collection consisting of all the elements of this collection and `xs`.

   Definition Classes
     BufferLike
   Annotations
     @migration
   Migration

     (Changed in version 2.8.0) `++` creates a new buffer. Use `++=` to add an element from this buffer and return that buffer itself.

5. #### abstract def ++[B](that: GenTraversableOnce[B]): ListBuffer[B]

   [use case] Returns a new list buffer containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new list buffer containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the list buffer is the most specific superclass encompassing the element types of the two operands (see example).

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this list buffer followed by all elements of `that`.

   Definition Classes
     GenTraversableLike

6. #### def ++[B >: A, That](that: GenTraversableOnce[B])(implicit bf: CanBuildFrom[ListBuffer[A], B, That]): That

   Returns a new list buffer containing the elements from the left hand operand followed by the elements from the right hand operand.

   Returns a new list buffer containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the list buffer is the most specific superclass encompassing the element types of the two operands (see example).

   Example:

           scala> val a = LinkedList(1)
           a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

           scala> val b = LinkedList(2)
           b: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val c = a ++ b
           c: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

           scala> val d = LinkedList('a')
           d: scala.collection.mutable.LinkedList[Char] = LinkedList(a)

           scala> val e = c ++ d
           e: scala.collection.mutable.LinkedList[AnyVal] = LinkedList(1, 2, a)

   B

     the element type of the returned collection.

   That

     the class of the returned collection. In the standard library configuration, `That` is always `ListBuffer[B]` because an implicit of type `CanBuildFrom[ListBuffer, B, ListBuffer[B]]` is defined in object `ListBuffer`.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ListBuffer`.

   returns

     a new collection of type `That` which contains all elements of this list buffer followed by all elements of `that`.

   Definition Classes
     TraversableLike → GenTraversableLike

7. #### def ++:[B >: A, That](that: Traversable[B])(implicit bf: CanBuildFrom[ListBuffer[A], B, That]): That

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand. It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one.

   Example:

           scala> val x = List(1)
           x: List[Int] = List(1)

           scala> val y = LinkedList(2)
           y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val z = x ++: y
           z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   This overload exists because: for the implementation of `++:` we should reuse that of `++` because many collections override it with more efficient versions.

   Since `TraversableOnce` has no `++` method, we have to implement that directly, but `Traversable` and down can use the overload.

   B

     the element type of the returned collection.

   That

     the class of the returned collection. In the standard library configuration, `That` is always `ListBuffer[B]` because an implicit of type `CanBuildFrom[ListBuffer, B, ListBuffer[B]]` is defined in object `ListBuffer`.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ListBuffer`.

   returns

     a new list buffer which contains all elements of this list buffer followed by all elements of `that`.

   Definition Classes
     TraversableLike

8. #### abstract def ++:[B](that: TraversableOnce[B]): ListBuffer[B]

   [use case] Concatenates this list buffer with the elements of a traversable collection.

   [use case]

   Concatenates this list buffer with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this list buffer followed by all elements of `that`.

   Definition Classes
     TraversableLike

9. #### def ++:[B >: A, That](that: TraversableOnce[B])(implicit bf: CanBuildFrom[ListBuffer[A], B, That]): That

   Concatenates this list buffer with the elements of a traversable collection.

   Concatenates this list buffer with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

   Example:

           scala> val x = List(1)
           x: List[Int] = List(1)

           scala> val y = LinkedList(2)
           y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val z = x ++: y
           z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   B

     the element type of the returned collection.

   That

     the class of the returned collection. In the standard library configuration, `That` is always `ListBuffer[B]` because an implicit of type `CanBuildFrom[ListBuffer, B, ListBuffer[B]]` is defined in object `ListBuffer`.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ListBuffer`.

   returns

     a new collection of type `That` which contains all elements of this list buffer followed by all elements of `that`.

   Definition Classes
     TraversableLike

10. #### def ++=(xs: TraversableOnce[A]): ListBuffer.this.type

    Appends all elements produced by a TraversableOnce to this list buffer.

    Appends all elements produced by a TraversableOnce to this list buffer.

    returns

      the list buffer itself.

    Definition Classes
      ListBuffer → Growable

11. #### def ++=:(xs: TraversableOnce[A]): ListBuffer.this.type

    Prepends elements to this buffer.

    Prepends elements to this buffer.

    xs

      the TraversableOnce containing the elements to prepend.

    returns

      the buffer itself.

    Definition Classes
      ListBuffer → BufferLike

12. #### abstract def +:(elem: A): ListBuffer[A]

    [use case] A copy of the list buffer with an element prepended.

    [use case]

    A copy of the list buffer with an element prepended.

    elem

      the prepended element

    returns

      a new collection of type `That` consisting of `elem` followed by all elements of this list buffer.

    Definition Classes
      GenSeqLike

13. #### def +:[B >: A, That](elem: B)(implicit bf: CanBuildFrom[ListBuffer[A], B, That]): That

    A copy of the list buffer with an element prepended.

    A copy of the list buffer with an element prepended.

    Note that :-ending operators are right associative (see example). Also, the original list buffer is not modified, so you will want to capture the result.

    Example:

             scala> val x = LinkedList(1)
             x: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

             scala> val y = 2 +: x
             y: scala.collection.mutable.LinkedList[Int] = LinkedList(2, 1)

             scala> println(x)
             LinkedList(1)

    B

      the element type of the returned list buffer.

    That

      the class of the returned collection. In the standard library configuration, `That` is always `ListBuffer[B]` because an implicit of type `CanBuildFrom[ListBuffer, B, ListBuffer[B]]` is defined in object `ListBuffer`.

    elem

      the prepended element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ListBuffer`.

    returns

      a new collection of type `That` consisting of `elem` followed by all elements of this list buffer.

    Definition Classes
      SeqLike → GenSeqLike

14. #### def +=(x: A): ListBuffer.this.type

    Appends a single element to this buffer.

    Appends a single element to this buffer. This operation takes constant time.

    x

      the element to append.

    returns

      this list buffer.

    Definition Classes
      ListBuffer → Builder → BufferLike → Growable

15. #### def +=(elem1: A, elem2: A, elems: A*): ListBuffer.this.type

    Appends two or more elements to this list buffer.

    Appends two or more elements to this list buffer.

    elem1

      the first element to append.

    elem2

      the second element to append.

    elems

      the remaining elements to append.

    returns

      the list buffer itself

    Definition Classes
      Growable

16. #### def +=:(x: A): ListBuffer.this.type

    Prepends a single element to this buffer.

    Prepends a single element to this buffer. This operation takes constant time.

    x

      the element to prepend.

    returns

      this list buffer.

    Definition Classes
      ListBuffer → BufferLike

17. #### def -(elem1: A, elem2: A, elems: A*): ListBuffer[A]

    Creates a new collection with all the elements of this collection except the two or more specified elements.

    Creates a new collection with all the elements of this collection except the two or more specified elements.

    elem1

      the first element to remove.

    elem2

      the second element to remove.

    elems

      the remaining elements to remove.

    returns

      a new collection consisting of all the elements of this collection except `elem1`, `elem2` and those in `elems`.

    Definition Classes
      BufferLike → Subtractable
    Annotations
      @migration
    Migration

      (Changed in version 2.8.0) `-` creates a new buffer. Use `-=` to remove an element from this buffer and return that buffer itself.

18. #### def -(elem: A): ListBuffer[A]

    Creates a new collection with all the elements of this collection except `elem`.

    Creates a new collection with all the elements of this collection except `elem`.

    elem

      the element to remove.

    returns

      a new collection consisting of all the elements of this collection except `elem`.

    Definition Classes
      BufferLike → Subtractable
    Annotations
      @migration
    Migration

      (Changed in version 2.8.0) `-` creates a new buffer. Use `-=` to remove an element from this buffer and return that buffer itself.

19. #### def --(xs: GenTraversableOnce[A]): ListBuffer[A]

    Creates a new collection with all the elements of this collection except those provided by the specified traversable object.

    Creates a new collection with all the elements of this collection except those provided by the specified traversable object.

    xs

      the traversable object.

    returns

      a new collection with all the elements of this collection except those in `xs`

    Definition Classes
      BufferLike → Subtractable
    Annotations
      @migration
    Migration

      (Changed in version 2.8.0) `--` creates a new buffer. Use `--=` to remove an element from this buffer and return that buffer itself.

20. #### def --=(xs: TraversableOnce[A]): ListBuffer.this.type

    Removes all elements produced by an iterator from this list buffer.

    Removes all elements produced by an iterator from this list buffer.

    returns

      the list buffer itself

    Definition Classes
      Shrinkable

21. #### def -=(elem: A): ListBuffer.this.type

    Remove a single element from this buffer.

    Remove a single element from this buffer. May take time linear in the buffer size.

    returns

      this list buffer.

    Definition Classes
      ListBuffer → BufferLike → Shrinkable

22. #### def -=(elem1: A, elem2: A, elems: A*): ListBuffer.this.type

    Removes two or more elements from this list buffer.

    Removes two or more elements from this list buffer.

    elem1

      the first element to remove.

    elem2

      the second element to remove.

    elems

      the remaining elements to remove.

    returns

      the list buffer itself

    Definition Classes
      Shrinkable

23. #### def /:[B](z: B)(op: (B, A) ⇒ B): B

    Applies a binary operator to a start value and all elements of this list buffer, going left to right.

    Applies a binary operator to a start value and all elements of this list buffer, going left to right.

    Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (5 /: a)(_+_)
             b: Int = 15

             scala> val c = (5 /: a)((x,y) => x + y)
             c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this list buffer, going left to right with the start value `z` on the left:

                      op(...op(op(z, x1), x2), ..., xn)

      where `x1, ..., xn` are the elements of this list buffer.

    Definition Classes
      TraversableForwarder → TraversableOnce → GenTraversableOnce

24. #### def /:\[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

    A syntactic sugar for out of order folding.

    A syntactic sugar for out of order folding. See `fold`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a /:\ 5)(_+_)
             b: Int = 15

    Definition Classes
      GenTraversableOnce

25. #### abstract def :+(elem: A): ListBuffer[A]

    [use case] A copy of this list buffer with an element appended.

    [use case]

    A copy of this list buffer with an element appended.

    elem

      the appended element

    returns

      a new collection of type `That` consisting of all elements of this list buffer followed by `elem`.

    Definition Classes
      GenSeqLike

26. #### def :+[B >: A, That](elem: B)(implicit bf: CanBuildFrom[ListBuffer[A], B, That]): That

    A copy of this list buffer with an element appended.

    A copy of this list buffer with an element appended.

    B

      the element type of the returned list buffer.

    That

      the class of the returned collection. In the standard library configuration, `That` is always `ListBuffer[B]` because an implicit of type `CanBuildFrom[ListBuffer, B, ListBuffer[B]]` is defined in object `ListBuffer`.

    elem

      the appended element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ListBuffer`.

    returns

      a new collection of type `That` consisting of all elements of this list buffer followed by `elem`.

    Definition Classes
      SeqLike → GenSeqLike

27. #### def :\[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this list buffer and a start value, going right to left.

    Applies a binary operator to all elements of this list buffer and a start value, going right to left.

    Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a :\ 5)(_+_)
             b: Int = 15

             scala> val c = (a :\ 5)((x,y) => x + y)
             c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value

    op

      the binary operator

    returns

      the result of inserting `op` between consecutive elements of this list buffer, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this list buffer.

    Definition Classes
      TraversableForwarder → TraversableOnce → GenTraversableOnce

28. #### def <<(cmd: Message[A]): Unit

    Send a message to this scriptable object.

    Send a message to this scriptable object.

    cmd

      the message to send.

    Definition Classes
      BufferLike → Scriptable

29. #### final def ==(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

30. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

31. #### def addString(b: StringBuilder): StringBuilder

    Appends all elements of this list buffer to a string builder.

    Appends all elements of this list buffer to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this list buffer without any separator string.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> val h = a.addString(b)
             b: StringBuilder = 1234

    b

      the string builder to which elements are appended.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableForwarder → TraversableOnce

32. #### def addString(b: StringBuilder, sep: String): StringBuilder

    Appends all elements of this list buffer to a string builder using a separator string.

    Appends all elements of this list buffer to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this list buffer, separated by the string `sep`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> a.addString(b, ", ")
             res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableForwarder → TraversableOnce

33. #### def addString(b: StringBuilder, start: String, sep: String, end: String): StringBuilder

    Appends all elements of this list buffer to a string builder using start, end, and separator strings.

    Appends all elements of this list buffer to a string builder using start, end, and separator strings. The written text begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this list buffer are separated by the string `sep`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> a.addString(b, "LinkedList(", ", ", ")")
             res1: StringBuilder = LinkedList(1, 2, 3, 4)

    b

      the string builder to which elements are appended.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableForwarder → TraversableOnce

34. #### def aggregate[B](z: B)(seqop: (B, A) ⇒ B, combop: (B, B) ⇒ B): B

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

           pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    B

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      TraversableOnce → GenTraversableOnce

35. #### def andThen[C](k: (A) ⇒ C): PartialFunction[Int, C]

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    C

      the result type of the transformation function.

    k

      the transformation function

    returns

      a partial function with the same domain as this partial function, which maps arguments `x` to `k(this(x))`.

    Definition Classes
      PartialFunction → Function1

36. #### def append(elems: A*): Unit

    Appends the given elements to this buffer.

    Appends the given elements to this buffer.

    elems

      the elements to append.

    Definition Classes
      BufferLike

37. #### def appendAll(xs: TraversableOnce[A]): Unit

    Appends the elements contained in a traversable object to this buffer.

    Appends the elements contained in a traversable object to this buffer.

    xs

      the traversable object containing the elements to append.

    Definition Classes
      BufferLike

38. #### def apply(n: Int): A

    Selects an element by its index in the list buffer.

    Selects an element by its index in the list buffer.

    Example:

           scala> val x = LinkedList(1, 2, 3, 4, 5)
           x: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4, 5)

           scala> x(3)
           res1: Int = 4

    returns

      the element of this list buffer at index `idx`, where `0` indicates the first element.

    Definition Classes
      ListBuffer → SeqForwarder → BufferLike → SeqLike → GenSeqLike → Function1
    Exceptions thrown
      `IndexOutOfBoundsException`

      if `idx` does not satisfy `0 <= idx < length`.

39. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

40. #### def canEqual(that: Any): Boolean

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    that

      The object with which this list buffer should be compared

    returns

      `true`, if this list buffer can possibly equal `that`, `false` otherwise. The test takes into consideration only the run-time types of objects but ignores their elements.

    Definition Classes
      IterableLike → Equals

41. #### def clear(): Unit

    Clears the buffer contents.

    Clears the buffer contents.

    Definition Classes
      ListBuffer → Builder → BufferLike → Growable

42. #### def clone(): ListBuffer[A]

    Returns a clone of this buffer.

    Returns a clone of this buffer.

    returns

      a `ListBuffer` with the same elements.

    Definition Classes
      ListBuffer → Cloneable → AnyRef

43. #### abstract def collect[B](pf: PartialFunction[A, B]): ListBuffer[B]

    [use case] Builds a new collection by applying a partial function to all elements of this list buffer on which the function is defined.

    [use case]

    Builds a new collection by applying a partial function to all elements of this list buffer on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the list buffer.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      GenTraversableLike

44. #### def collect[B, That](pf: PartialFunction[A, B])(implicit bf: CanBuildFrom[ListBuffer[A], B, That]): That

    Builds a new collection by applying a partial function to all elements of this list buffer on which the function is defined.

    Builds a new collection by applying a partial function to all elements of this list buffer on which the function is defined.

    B

      the element type of the returned collection.

    That

      the class of the returned collection. In the standard library configuration, `That` is always `ListBuffer[B]` because an implicit of type `CanBuildFrom[ListBuffer, B, ListBuffer[B]]` is defined in object `ListBuffer`.

    pf

      the partial function which filters and maps the list buffer.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ListBuffer`.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

45. #### def collectFirst[B](pf: PartialFunction[A, B]): Option[B]

    Finds the first element of the list buffer for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the list buffer for which the given partial function is defined, and applies the partial function to it.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Definition Classes
      TraversableOnce
    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

46. #### def combinations(n: Int): Iterator[ListBuffer[A]]

    Iterates over combinations.

    Iterates over combinations.

    returns

      An Iterator which traverses the possible n-element combinations of this list buffer.

    Definition Classes
      SeqLike
    Example:

    1. `"abbbc".combinations(2) = Iterator(ab, ac, bb, bc)`

47. #### def companion: GenericCompanion[ListBuffer]

    The factory companion object that builds instances of class ListBuffer.

    The factory companion object that builds instances of class ListBuffer. (or its `Iterable` superclass where class ListBuffer is not a `Seq`.)

    Definition Classes
      ListBuffer → Buffer → Seq → Seq → GenSeq → Iterable → Iterable → GenIterable → Traversable → Traversable → GenTraversable → GenericTraversableTemplate

48. #### def compose[A](g: (A) ⇒ Int): (A) ⇒ A

    Composes two instances of Function1 in a new Function1, with this function applied last.

    Composes two instances of Function1 in a new Function1, with this function applied last.

    A

      the type to which function `g` can be applied

    g

      a function A => T1

    returns

      a new function `f` such that `f(x) == apply(g(x))`

    Definition Classes
      Function1

49. #### def contains(elem: Any): Boolean

    Tests whether this list buffer contains a given value as an element.

    Tests whether this list buffer contains a given value as an element.

    elem

      the element to test.

    returns

      `true` if this list buffer has an element that is is equal (wrt `==`) to `elem`, `false` otherwise.

    Definition Classes
      SeqForwarder → SeqLike

50. #### def containsSlice[B](that: GenSeq[B]): Boolean

    Tests whether this list buffer contains a given sequence as a slice.

    Tests whether this list buffer contains a given sequence as a slice.

    that

      the sequence to test

    returns

      `true` if this list buffer contains a slice with the same elements as `that`, otherwise `false`.

    Definition Classes
      SeqForwarder → SeqLike

51. #### abstract def copyToArray(xs: Array[A]): Unit

    [use case] Copies values of this list buffer to an array.

    [use case]

    Copies values of this list buffer to an array. Fills the given array `xs` with values of this list buffer. Copying will stop once either the end of the current list buffer is reached, or the end of the array is reached.

    xs

      the array to fill.

    Definition Classes
      GenTraversableOnce

52. #### def copyToArray[B >: A](xs: Array[B]): Unit

    Copies values of this list buffer to an array.

    Copies values of this list buffer to an array. Fills the given array `xs` with values of this list buffer. Copying will stop once either the end of the current list buffer is reached, or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    Definition Classes
      TraversableForwarder → TraversableOnce → GenTraversableOnce

53. #### abstract def copyToArray(xs: Array[A], start: Int): Unit

    [use case] Copies values of this list buffer to an array.

    [use case]

    Copies values of this list buffer to an array. Fills the given array `xs` with values of this list buffer, beginning at index `start`. Copying will stop once either the end of the current list buffer is reached, or the end of the array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      GenTraversableOnce

54. #### def copyToArray[B >: A](xs: Array[B], start: Int): Unit

    Copies values of this list buffer to an array.

    Copies values of this list buffer to an array. Fills the given array `xs` with values of this list buffer, beginning at index `start`. Copying will stop once either the end of the current list buffer is reached, or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      TraversableForwarder → TraversableOnce → GenTraversableOnce

55. #### abstract def copyToArray(xs: Array[A], start: Int, len: Int): Unit

    [use case] Copies elements of this list buffer to an array.

    [use case]

    Copies elements of this list buffer to an array. Fills the given array `xs` with at most `len` elements of this list buffer, starting at position `start`. Copying will stop once either the end of the current list buffer is reached, or the end of the array is reached, or `len` elements have been copied.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      TraversableLike

56. #### def copyToArray[B >: A](xs: Array[B], start: Int, len: Int): Unit

    Copies elements of this list buffer to an array.

    Copies elements of this list buffer to an array. Fills the given array `xs` with at most `len` elements of this list buffer, starting at position `start`. Copying will stop once either the end of the current list buffer is reached, or the end of the array is reached, or `len` elements have been copied.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      TraversableForwarder → TraversableLike → TraversableOnce → GenTraversableOnce

57. #### def copyToBuffer[B >: A](dest: Buffer[B]): Unit

    Copies all elements of this list buffer to a buffer.

    Copies all elements of this list buffer to a buffer.

    dest

      The buffer to which elements are copied.

    Definition Classes
      TraversableForwarder → TraversableOnce

58. #### def corresponds[B](that: GenSeq[B])(p: (A, B) ⇒ Boolean): Boolean

    Tests whether every element of this list buffer relates to the corresponding element of another sequence by satisfying a test predicate.

    Tests whether every element of this list buffer relates to the corresponding element of another sequence by satisfying a test predicate.

    B

      the type of the elements of `that`

    that

      the other sequence

    p

      the test predicate, which relates elements from both sequences

    returns

      `true` if both sequences have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this list buffer and `y` of `that`, otherwise `false`.

    Definition Classes
      SeqForwarder → SeqLike → GenSeqLike

59. #### def count(p: (A) ⇒ Boolean): Int

    Counts the number of elements in the list buffer which satisfy a predicate.

    Counts the number of elements in the list buffer which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      TraversableForwarder → TraversableOnce → GenTraversableOnce

60. #### abstract def diff(that: Seq[A]): ListBuffer[A]

    [use case] Computes the multiset difference between this list buffer and another sequence.

    [use case]

    Computes the multiset difference between this list buffer and another sequence.

    that

      the sequence of elements to remove

    returns

      a new collection of type `That` which contains all elements of this list buffer except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      SeqLike

61. #### def diff[B >: A](that: GenSeq[B]): ListBuffer[A]

    Computes the multiset difference between this list buffer and another sequence.

    Computes the multiset difference between this list buffer and another sequence.

    B

      the element type of the returned list buffer.

    that

      the sequence of elements to remove

    returns

      a new collection of type `That` which contains all elements of this list buffer except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      SeqLike → GenSeqLike

62. #### def distinct: ListBuffer[A]

    Builds a new list buffer from this list buffer without any duplicate elements.

    Builds a new list buffer from this list buffer without any duplicate elements.

    returns

      A new list buffer which contains the first occurrence of every element of this list buffer.

    Definition Classes
      SeqLike → GenSeqLike

63. #### def drop(n: Int): ListBuffer[A]

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    n

      the number of elements to drop from this list buffer.

    returns

      a list buffer consisting of all elements of this list buffer except the first `n` ones, or else the empty list buffer, if this list buffer has less than `n` elements.

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike

64. #### def dropRight(n: Int): ListBuffer[A]

    Selects all elements except last n ones.

    Selects all elements except last n ones.

    n

      The number of elements to take

    returns

      a list buffer consisting of all elements of this list buffer except the last `n` ones, or else the empty list buffer, if this list buffer has less than `n` elements.

    Definition Classes
      IterableLike

65. #### def dropWhile(p: (A) ⇒ Boolean): ListBuffer[A]

    Drops longest prefix of elements that satisfy a predicate.

    Drops longest prefix of elements that satisfy a predicate.

    p

      The predicate used to test elements.

    returns

      the longest suffix of this list buffer whose first element does not satisfy the predicate `p`.

    Definition Classes
      TraversableLike → GenTraversableLike

66. #### def endsWith[B](that: GenSeq[B]): Boolean

    Tests whether this list buffer ends with the given sequence.

    Tests whether this list buffer ends with the given sequence.

    that

      the sequence to test

    returns

      `true` if this list buffer has `that` as a suffix, `false` otherwise.

    Definition Classes
      SeqForwarder → SeqLike → GenSeqLike

67. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

68. #### def equals(that: Any): Boolean

    The equals method for arbitrary sequences.

    The equals method for arbitrary sequences. Compares this sequence to some other object.

    that

      The object to compare the sequence to

    returns

      `true` if `that` is a sequence that has the same elements as this sequence in the same order, `false` otherwise

    Definition Classes
      ListBuffer → GenSeqLike → Equals → AnyRef → Any

69. #### def exists(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some of the elements of this list buffer.

    Tests whether a predicate holds for some of the elements of this list buffer.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for some of the elements of this list buffer, otherwise `false`.

    Definition Classes
      TraversableForwarder → TraversableLike → TraversableOnce → GenTraversableOnce

70. #### def filter(p: (A) ⇒ Boolean): ListBuffer[A]

    Selects all elements of this list buffer which satisfy a predicate.

    Selects all elements of this list buffer which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new list buffer consisting of all elements of this list buffer that satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

71. #### def filterNot(p: (A) ⇒ Boolean): ListBuffer[A]

    Selects all elements of this list buffer which do not satisfy a predicate.

    Selects all elements of this list buffer which do not satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new list buffer consisting of all elements of this list buffer that do not satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

72. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

73. #### def find(p: (A) ⇒ Boolean): Option[A]

    Finds the first element of the list buffer satisfying a predicate, if any.

    Finds the first element of the list buffer satisfying a predicate, if any.

    p

      the predicate used to test elements.

    returns

      an option value containing the first element in the list buffer that satisfies `p`, or `None` if none exists.

    Definition Classes
      TraversableForwarder → TraversableLike → TraversableOnce → GenTraversableOnce

74. #### def findIndexOf(p: (A) ⇒ Boolean): Int

    Returns index of the first element satisfying a predicate, or `-1`.

    Returns index of the first element satisfying a predicate, or `-1`.

    Definition Classes
      SeqForwarder → SeqLike

75. #### abstract def flatMap[B](f: (A) ⇒ GenTraversableOnce[B]): ListBuffer[B]

    [use case] Builds a new collection by applying a function to all elements of this list buffer and using the elements of the resulting collections.

    [use case]

    Builds a new collection by applying a function to all elements of this list buffer and using the elements of the resulting collections. For example:

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this list buffer and concatenating the results.

    Definition Classes
      GenTraversableLike

76. #### def flatMap[B, That](f: (A) ⇒ GenTraversableOnce[B])(implicit bf: CanBuildFrom[ListBuffer[A], B, That]): That

    Builds a new collection by applying a function to all elements of this list buffer and using the elements of the resulting collections.

    Builds a new collection by applying a function to all elements of this list buffer and using the elements of the resulting collections. For example:

         def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of list buffer. This might cause unexpected results sometimes. For example:

         // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
         def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

         // lettersOf will return a Set[Char], not a Seq
         def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

         // xs will be a an Iterable[Int]
         val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

         // ys will be a Map[Int, Int]
         val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    That

      the class of the returned collection. In the standard library configuration, `That` is always `ListBuffer[B]` because an implicit of type `CanBuildFrom[ListBuffer, B, ListBuffer[B]]` is defined in object `ListBuffer`.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ListBuffer`.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this list buffer and concatenating the results.

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic

77. #### abstract def flatten[B]: ListBuffer[B]

    [use case] Converts this list buffer of traversable collections into a list buffer formed by the elements of these traversable collections.

    [use case]

    Converts this list buffer of traversable collections into a list buffer formed by the elements of these traversable collections.

    B

      the type of the elements of each traversable collection.

    returns

      a new list buffer resulting from concatenating all element list buffers.

    Definition Classes
      GenericTraversableTemplate

78. #### def fold[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this list buffer using the specified associative binary operator.

    Folds the elements of this list buffer using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      TraversableOnce → GenTraversableOnce

79. #### def foldLeft[B](z: B)(op: (B, A) ⇒ B): B

    Applies a binary operator to a start value and all elements of this list buffer, going left to right.

    Applies a binary operator to a start value and all elements of this list buffer, going left to right.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this list buffer, going left to right with the start value `z` on the left:

                      op(...op(z, x1), x2, ..., xn)

      where `x1, ..., xn` are the elements of this list buffer.

    Definition Classes
      TraversableForwarder → TraversableOnce → GenTraversableOnce

80. #### def foldRight[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this list buffer and a start value, going right to left.

    Applies a binary operator to all elements of this list buffer and a start value, going right to left.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this list buffer, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this list buffer.

    Definition Classes
      TraversableForwarder → TraversableOnce → GenTraversableOnce

81. #### def forall(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this list buffer.

    Tests whether a predicate holds for all elements of this list buffer.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for all elements of this list buffer, otherwise `false`.

    Definition Classes
      TraversableForwarder → TraversableLike → TraversableOnce → GenTraversableOnce

82. #### abstract def foreach(f: (A) ⇒ Unit): Unit

    [use case] Applies a function `f` to all elements of this list buffer.

    [use case]

    Applies a function `f` to all elements of this list buffer.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      GenericTraversableTemplate

83. #### def foreach[B](f: (A) ⇒ B): Unit

    Applies a function `f` to all elements of this list buffer.

    Applies a function `f` to all elements of this list buffer.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      TraversableForwarder → GenericTraversableTemplate → TraversableLike → GenTraversableLike → TraversableOnce → GenTraversableOnce → FilterMonadic

84. #### def genericBuilder[B]: Builder[B, ListBuffer[B]]

    The generic builder that builds instances of ListBuffer at arbitrary element types.

    The generic builder that builds instances of ListBuffer at arbitrary element types.

    Definition Classes
      GenericTraversableTemplate

85. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

86. #### def groupBy[K](f: (A) ⇒ K): Map[K, ListBuffer[A]]

    Partitions this list buffer into a map of list buffers according to some discriminator function.

    Partitions this list buffer into a map of list buffers according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new list buffer.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to list buffers such that the following invariant holds:

                          (xs partition f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a list buffer of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      TraversableLike → GenTraversableLike

87. #### def grouped(size: Int): Iterator[ListBuffer[A]]

    Partitions elements in fixed size list buffers.

    Partitions elements in fixed size list buffers.

    size

      the number of elements per group

    returns

      An iterator producing list buffers of size `size`, except the last will be truncated if the elements don't divide evenly.

    Definition Classes
      IterableLike
    See also

      Iterator#grouped

88. #### def hasDefiniteSize: Boolean

    Tests whether this list buffer is known to have a finite size.

    Tests whether this list buffer is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end.

    Note: many collection methods will not work on collections of infinite sizes.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

    Definition Classes
      TraversableForwarder → TraversableLike → TraversableOnce → GenTraversableOnce

89. #### def hashCode(): Int

    Hashcodes for ListBuffer produce a value from the hashcodes of all the elements of the list buffer.

    Hashcodes for ListBuffer produce a value from the hashcodes of all the elements of the list buffer.

    returns

      the hash code value for this object.

    Definition Classes
      GenSeqLike → AnyRef → Any

90. #### def head: A

    Selects the first element of this list buffer.

    Selects the first element of this list buffer.

    returns

      the first element of this list buffer.

    Definition Classes
      TraversableForwarder → GenericTraversableTemplate → TraversableLike → GenTraversableLike
    Exceptions thrown
      `NoSuchElementException`

      if the list buffer is empty.

91. #### def headOption: Option[A]

    Optionally selects the first element.

    Optionally selects the first element.

    returns

      the first element of this list buffer if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableForwarder → TraversableLike

92. #### abstract def indexOf(elem: A, from: Int): Int

    [use case] Finds index of first occurrence of some value in this list buffer after or at some start index.

    [use case]

    Finds index of first occurrence of some value in this list buffer after or at some start index.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this list buffer that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

93. #### def indexOf[B >: A](elem: B, from: Int): Int

    Finds index of first occurrence of some value in this list buffer after or at some start index.

    Finds index of first occurrence of some value in this list buffer after or at some start index.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this list buffer that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      SeqForwarder → GenSeqLike

94. #### abstract def indexOf(elem: A): Int

    [use case] Finds index of first occurrence of some value in this list buffer.

    [use case]

    Finds index of first occurrence of some value in this list buffer.

    elem

      the element value to search for.

    returns

      the index of the first element of this list buffer that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

95. #### def indexOf[B >: A](elem: B): Int

    Finds index of first occurrence of some value in this list buffer.

    Finds index of first occurrence of some value in this list buffer.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    returns

      the index of the first element of this list buffer that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      SeqForwarder → GenSeqLike

96. #### def indexOfSlice[B >: A](that: GenSeq[B], from: Int): Int

    Finds first index after or at a start index where this list buffer contains a given sequence as a slice.

    Finds first index after or at a start index where this list buffer contains a given sequence as a slice.

    that

      the sequence to test

    from

      the start index

    returns

      the first index `>= from` such that the elements of this list buffer starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqForwarder → SeqLike

97. #### def indexOfSlice[B >: A](that: GenSeq[B]): Int

    Finds first index where this list buffer contains a given sequence as a slice.

    Finds first index where this list buffer contains a given sequence as a slice.

    that

      the sequence to test

    returns

      the first index such that the elements of this list buffer starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqForwarder → SeqLike

98. #### def indexWhere(p: (A) ⇒ Boolean, from: Int): Int

    Finds index of the first element satisfying some predicate after or at some start index.

    Finds index of the first element satisfying some predicate after or at some start index.

    p

      the predicate used to test elements.

    from

      the start index

    returns

      the index `>= from` of the first element of this list buffer that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      SeqForwarder → SeqLike → GenSeqLike

99. #### def indexWhere(p: (A) ⇒ Boolean): Int

    Finds index of first element satisfying some predicate.

    Finds index of first element satisfying some predicate.

    p

      the predicate used to test elements.

    returns

      the index of the first element of this list buffer that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      SeqForwarder → GenSeqLike

100. #### def indices: Range

     Produces the range of all indices of this sequence.

     Produces the range of all indices of this sequence.

     returns

       a `Range` value from `0` to one less than the length of this list buffer.

     Definition Classes
       SeqForwarder → SeqLike

101. #### def init: ListBuffer[A]

     Selects all elements except the last.

     Selects all elements except the last.

     returns

       a list buffer consisting of all elements of this list buffer except the last one.

     Definition Classes
       TraversableLike
     Exceptions thrown
       `UnsupportedOperationException`

       if the list buffer is empty.

102. #### def inits: Iterator[ListBuffer[A]]

     Iterates over the inits of this list buffer.

     Iterates over the inits of this list buffer. The first value will be this list buffer and the final one will be an empty list buffer, with the intervening values the results of successive applications of `init`.

     returns

       an iterator over all the inits of this list buffer

     Definition Classes
       TraversableLike
     Example:

     1. `List(1,2,3).inits = Iterator(List(1,2,3), List(1,2), List(1), Nil)`

103. #### def insert(n: Int, elems: A*): Unit

     Inserts new elements at a given index into this buffer.

     Inserts new elements at a given index into this buffer.

     n

       the index where new elements are inserted.

     elems

       the traversable collection containing the elements to insert.

     Definition Classes
       BufferLike
     Exceptions thrown
       IndexOutOfBoundsException

       if the index `n` is not in the valid range `0 <= n <= length`.

104. #### def insertAll(n: Int, seq: Traversable[A]): Unit

     Inserts new elements at the index `n`.

     Inserts new elements at the index `n`. Opposed to method `update`, this method will not replace an element with a new one. Instead, it will insert a new element at index `n`.

     n

       the index where a new element will be inserted.

     Definition Classes
       ListBuffer → BufferLike
     Exceptions thrown
       Predef.IndexOutOfBoundsException

       if `n` is out of bounds.

105. #### abstract def intersect(that: Seq[A]): ListBuffer[A]

     [use case] Computes the multiset intersection between this list buffer and another sequence.

     [use case]

     Computes the multiset intersection between this list buffer and another sequence.

     that

       the sequence of elements to intersect with.

     returns

       a new collection of type `That` which contains all elements of this list buffer which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

     Definition Classes
       SeqLike

106. #### def intersect[B >: A](that: GenSeq[B]): ListBuffer[A]

     Computes the multiset intersection between this list buffer and another sequence.

     Computes the multiset intersection between this list buffer and another sequence.

     B

       the element type of the returned list buffer.

     that

       the sequence of elements to intersect with.

     returns

       a new collection of type `That` which contains all elements of this list buffer which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

     Definition Classes
       SeqLike → GenSeqLike

107. #### def isDefinedAt(x: Int): Boolean

     Tests whether this list buffer contains given index.

     Tests whether this list buffer contains given index.

     The implementations of methods `apply` and `isDefinedAt` turn a `Seq[A]` into a `PartialFunction[Int, A]`.

     returns

       `true` if this list buffer contains an element at position `idx`, `false` otherwise.

     Definition Classes
       SeqForwarder → GenSeqLike → PartialFunction

108. #### def isEmpty: Boolean

     Tests whether this list buffer is empty.

     Tests whether this list buffer is empty.

     returns

       `true` if the list buffer contain no elements, `false` otherwise.

     Definition Classes
       TraversableForwarder → GenericTraversableTemplate → TraversableLike → TraversableOnce → GenTraversableOnce

109. #### final def isInstanceOf[T0]: Boolean

     Test whether the dynamic type of the receiver object is `T0`.

     Test whether the dynamic type of the receiver object is `T0`.

     Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

     returns

       `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

     Definition Classes
       Any

110. #### final def isTraversableAgain: Boolean

     Tests whether this list buffer can be repeatedly traversed.

     Tests whether this list buffer can be repeatedly traversed.

     returns

       `true`

     Definition Classes
       GenTraversableLike → GenTraversableOnce

111. #### def iterator: Iterator[A]

     Creates a new iterator over all elements contained in this iterable object.

     Creates a new iterator over all elements contained in this iterable object.

     returns

       the new iterator

     Definition Classes
       ListBuffer → IterableForwarder → IterableLike → GenIterableLike

112. #### def last: A

     Selects the last element.

     Selects the last element.

     returns

       The last element of this list buffer.

     Definition Classes
       TraversableForwarder → TraversableLike
     Exceptions thrown
       NoSuchElementException

       If the list buffer is empty.

113. #### abstract def lastIndexOf(elem: A, end: Int): Int

     [use case] Finds index of last occurrence of some value in this list buffer before or at a given end index.

     [use case]

     Finds index of last occurrence of some value in this list buffer before or at a given end index.

     elem

       the element value to search for.

     end

       the end index.

     returns

       the index `<= end` of the last element of this list buffer that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike

114. #### def lastIndexOf[B >: A](elem: B, end: Int): Int

     Finds index of last occurrence of some value in this list buffer before or at a given end index.

     Finds index of last occurrence of some value in this list buffer before or at a given end index.

     B

       the type of the element `elem`.

     elem

       the element value to search for.

     end

       the end index.

     returns

       the index `<= end` of the last element of this list buffer that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

     Definition Classes
       SeqForwarder → GenSeqLike

115. #### abstract def lastIndexOf(elem: A): Int

     [use case] Finds index of last occurrence of some value in this list buffer.

     [use case]

     Finds index of last occurrence of some value in this list buffer.

     elem

       the element value to search for.

     returns

       the index of the last element of this list buffer that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike

116. #### def lastIndexOf[B >: A](elem: B): Int

     Finds index of last occurrence of some value in this list buffer.

     Finds index of last occurrence of some value in this list buffer.

     B

       the type of the element `elem`.

     elem

       the element value to search for.

     returns

       the index of the last element of this list buffer that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

     Definition Classes
       SeqForwarder → GenSeqLike

117. #### def lastIndexOfSlice[B >: A](that: GenSeq[B], end: Int): Int

     Finds last index before or at a given end index where this list buffer contains a given sequence as a slice.

     Finds last index before or at a given end index where this list buffer contains a given sequence as a slice.

     that

       the sequence to test

     end

       the end index

     returns

       the last index `<= end` such that the elements of this list buffer starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

     Definition Classes
       SeqForwarder → SeqLike

118. #### def lastIndexOfSlice[B >: A](that: GenSeq[B]): Int

     Finds last index where this list buffer contains a given sequence as a slice.

     Finds last index where this list buffer contains a given sequence as a slice.

     that

       the sequence to test

     returns

       the last index such that the elements of this list buffer starting a this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

     Definition Classes
       SeqForwarder → SeqLike

119. #### def lastIndexWhere(p: (A) ⇒ Boolean, end: Int): Int

     Finds index of last element satisfying some predicate before or at given end index.

     Finds index of last element satisfying some predicate before or at given end index.

     p

       the predicate used to test elements.

     returns

       the index `<= end` of the last element of this list buffer that satisfies the predicate `p`, or `-1`, if none exists.

     Definition Classes
       SeqForwarder → SeqLike → GenSeqLike

120. #### def lastIndexWhere(p: (A) ⇒ Boolean): Int

     Finds index of last element satisfying some predicate.

     Finds index of last element satisfying some predicate.

     p

       the predicate used to test elements.

     returns

       the index of the last element of this list buffer that satisfies the predicate `p`, or `-1`, if none exists.

     Definition Classes
       SeqForwarder → GenSeqLike

121. #### def lastOption: Option[A]

     Optionally selects the last element.

     Optionally selects the last element.

     returns

       the last element of this list buffer$ if it is nonempty, `None` if it is empty.

     Definition Classes
       TraversableForwarder → TraversableLike

122. #### def length: Int

     The current length of the buffer.

     The current length of the buffer.

     This operation takes constant time.

     returns

       the number of elements in this list buffer.

     Definition Classes
       ListBuffer → SeqForwarder → BufferLike → SeqLike → GenSeqLike

123. #### def lengthCompare(len: Int): Int

     Compares the length of this list buffer to a test value.

     Compares the length of this list buffer to a test value.

     len

       the test value that gets compared with the length.

     returns

       A value `x` where

                  x <  0       if this.length <  len
                  x == 0       if this.length == len
                  x >  0       if this.length >  len

       The method as implemented here does not call `length` directly; its running time is `O(length min len)` instead of `O(length)`. The method should be overwritten if computing `length` is cheap.

     Definition Classes
       SeqForwarder → SeqLike

124. #### def lift: (Int) ⇒ Option[A]

     Turns this partial function into an plain function returning an `Option` result.

     Turns this partial function into an plain function returning an `Option` result.

     returns

       a function that takes an argument `x` to `Some(this(x))` if `this` is defined for `x`, and to `None` otherwise.

     Definition Classes
       PartialFunction
     See also

       Function.unlift

125. #### abstract def map[B](f: (A) ⇒ B): ListBuffer[B]

     [use case] Builds a new collection by applying a function to all elements of this list buffer.

     [use case]

     Builds a new collection by applying a function to all elements of this list buffer.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this list buffer and collecting the results.

     Definition Classes
       GenTraversableLike

126. #### def map[B, That](f: (A) ⇒ B)(implicit bf: CanBuildFrom[ListBuffer[A], B, That]): That

     Builds a new collection by applying a function to all elements of this list buffer.

     Builds a new collection by applying a function to all elements of this list buffer.

     B

       the element type of the returned collection.

     That

       the class of the returned collection. In the standard library configuration, `That` is always `ListBuffer[B]` because an implicit of type `CanBuildFrom[ListBuffer, B, ListBuffer[B]]` is defined in object `ListBuffer`.

     f

       the function to apply to each element.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ListBuffer`.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this list buffer and collecting the results.

     Definition Classes
       TraversableLike → GenTraversableLike → FilterMonadic

127. #### def mapResult[NewTo](f: (List[A]) ⇒ NewTo): Builder[A, NewTo]

     Creates a new builder by applying a transformation function to the results of this builder.

     Creates a new builder by applying a transformation function to the results of this builder.

     NewTo

       the type of collection returned by `f`.

     f

       the transformation function.

     returns

       a new builder which is the same as the current builder except that a transformation function is applied to this builder's result.

     Definition Classes
       Builder

128. #### abstract def max: A

     [use case] Finds the largest element.

     [use case]

     Finds the largest element.

     returns

       the largest element of this list buffer with respect to the ordering `cmp`.

     Definition Classes
       GenTraversableOnce

129. #### def max[B >: A](implicit cmp: Ordering[B]): A

     Finds the largest element.

     Finds the largest element.

     B

       The type over which the ordering is defined.

     cmp

       An ordering to be used for comparing elements.

     returns

       the largest element of this list buffer with respect to the ordering `cmp`.

     Definition Classes
       TraversableForwarder → TraversableOnce → GenTraversableOnce

130. #### def maxBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

     Definition Classes
       TraversableOnce → GenTraversableOnce

131. #### abstract def min: A

     [use case] Finds the smallest element.

     [use case]

     Finds the smallest element.

     returns

       the smallest element of this list buffer with respect to the ordering `cmp`.

     Definition Classes
       GenTraversableOnce

132. #### def min[B >: A](implicit cmp: Ordering[B]): A

     Finds the smallest element.

     Finds the smallest element.

     B

       The type over which the ordering is defined.

     cmp

       An ordering to be used for comparing elements.

     returns

       the smallest element of this list buffer with respect to the ordering `cmp`.

     Definition Classes
       TraversableForwarder → TraversableOnce → GenTraversableOnce

133. #### def minBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

     Definition Classes
       TraversableOnce → GenTraversableOnce

134. #### def mkString: String

     Displays all elements of this list buffer in a string.

     Displays all elements of this list buffer in a string.

     returns

       a string representation of this list buffer. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this list buffer follow each other without any separator string.

     Definition Classes
       TraversableForwarder → TraversableOnce → GenTraversableOnce

135. #### def mkString(sep: String): String

     Displays all elements of this list buffer in a string using a separator string.

     Displays all elements of this list buffer in a string using a separator string.

     sep

       the separator string.

     returns

       a string representation of this list buffer. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this list buffer are separated by the string `sep`.

     Definition Classes
       TraversableForwarder → TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("|") = "1|2|3"`

136. #### def mkString(start: String, sep: String, end: String): String

     Displays all elements of this list buffer in a string using start, end, and separator strings.

     Displays all elements of this list buffer in a string using start, end, and separator strings.

     start

       the starting string.

     sep

       the separator string.

     end

       the ending string.

     returns

       a string representation of this list buffer. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this list buffer are separated by the string `sep`.

     Definition Classes
       TraversableForwarder → TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

137. #### final def ne(arg0: AnyRef): Boolean

     Equivalent to `!(this eq that)`.

     Equivalent to `!(this eq that)`.

     returns

       `true` if the argument is not a reference to the receiver object; `false` otherwise.

     Definition Classes
       AnyRef

138. #### def newBuilder: Builder[A, ListBuffer[A]]

     The builder that builds instances of type ListBuffer[A]

     The builder that builds instances of type ListBuffer[A]

     Attributes
       protected[this]
     Definition Classes
       GenericTraversableTemplate → HasNewBuilder

139. #### def nonEmpty: Boolean

     Tests whether the list buffer is not empty.

     Tests whether the list buffer is not empty.

     returns

       `true` if the list buffer contains at least one element, `false` otherwise.

     Definition Classes
       TraversableForwarder → TraversableOnce → GenTraversableOnce

140. #### final def notify(): Unit

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

141. #### final def notifyAll(): Unit

     Wakes up all threads that are waiting on the receiver object's monitor.

     Wakes up all threads that are waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

142. #### def orElse[A1 <: Int, B1 >: A](that: PartialFunction[A1, B1]): PartialFunction[A1, B1]

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     A1

       the argument type of the fallback function

     B1

       the result type of the fallback function

     that

       the fallback function

     returns

       a partial function which has as domain the union of the domains of this partial function and `that`. The resulting partial function takes `x` to `this(x)` where `this` is defined, and to `that(x)` where it is not.

     Definition Classes
       PartialFunction

143. #### abstract def padTo(len: Int, elem: A): ListBuffer[A]

     [use case] A copy of this list buffer with an element value appended until a given target length is reached.

     [use case]

     A copy of this list buffer with an element value appended until a given target length is reached.

     len

       the target length

     elem

       the padding value

     returns

       a new collection of type `That` consisting of all elements of this list buffer followed by the minimal number of occurrences of `elem` so that the resulting collection has a length of at least `len`.

     Definition Classes
       GenSeqLike

144. #### def padTo[B >: A, That](len: Int, elem: B)(implicit bf: CanBuildFrom[ListBuffer[A], B, That]): That

     A copy of this list buffer with an element value appended until a given target length is reached.

     A copy of this list buffer with an element value appended until a given target length is reached.

     B

       the element type of the returned list buffer.

     That

       the class of the returned collection. In the standard library configuration, `That` is always `ListBuffer[B]` because an implicit of type `CanBuildFrom[ListBuffer, B, ListBuffer[B]]` is defined in object `ListBuffer`.

     len

       the target length

     elem

       the padding value

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ListBuffer`.

     returns

       a new collection of type `That` consisting of all elements of this list buffer followed by the minimal number of occurrences of `elem` so that the resulting collection has a length of at least `len`.

     Definition Classes
       SeqLike → GenSeqLike

145. #### def par: ParSeq[A]

     Returns a parallel implementation of this collection.

     Returns a parallel implementation of this collection.

     For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

     Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

     All parallel collections return a reference to themselves.

     returns

       a parallel implementation of this collection

     Definition Classes
       Parallelizable

146. #### def parCombiner: Combiner[A, ParSeq[A]]

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     returns

       a combiner for the parallel collection of type `ParRepr`

     Attributes
       protected[this]
     Definition Classes
       SeqLike → SeqLike → TraversableLike → Parallelizable

147. #### def partition(p: (A) ⇒ Boolean): (ListBuffer[A], ListBuffer[A])

     Partitions this list buffer in two list buffers according to a predicate.

     Partitions this list buffer in two list buffers according to a predicate.

     p

       the predicate on which to partition.

     returns

       a pair of list buffers: the first list buffer consists of all elements that satisfy the predicate `p` and the second list buffer consists of all elements that don't. The relative order of the elements in the resulting list buffers is the same as in the original list buffer.

     Definition Classes
       TraversableLike → GenTraversableLike

148. #### abstract def patch(from: Int, that: GenSeq[A], replaced: Int): ListBuffer[A]

     [use case] Produces a new list buffer where a slice of elements in this list buffer is replaced by another sequence.

     [use case]

     Produces a new list buffer where a slice of elements in this list buffer is replaced by another sequence.

     from

       the index of the first replaced element

     replaced

       the number of elements to drop in the original list buffer

     returns

       a new list buffer consisting of all elements of this list buffer except that `replaced` elements starting from `from` are replaced by `patch`.

     Definition Classes
       GenSeqLike

149. #### def patch[B >: A, That](from: Int, patch: GenSeq[B], replaced: Int)(implicit bf: CanBuildFrom[ListBuffer[A], B, That]): That

     Produces a new list buffer where a slice of elements in this list buffer is replaced by another sequence.

     Produces a new list buffer where a slice of elements in this list buffer is replaced by another sequence.

     B

       the element type of the returned list buffer.

     That

       the class of the returned collection. In the standard library configuration, `That` is always `ListBuffer[B]` because an implicit of type `CanBuildFrom[ListBuffer, B, ListBuffer[B]]` is defined in object `ListBuffer`.

     from

       the index of the first replaced element

     patch

       the replacement sequence

     replaced

       the number of elements to drop in the original list buffer

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ListBuffer`.

     returns

       a new list buffer consisting of all elements of this list buffer except that `replaced` elements starting from `from` are replaced by `patch`.

     Definition Classes
       SeqLike → GenSeqLike

150. #### def permutations: Iterator[ListBuffer[A]]

     Iterates over distinct permutations.

     Iterates over distinct permutations.

     returns

       An Iterator which traverses the distinct permutations of this list buffer.

     Definition Classes
       SeqLike
     Example:

     1. `"abb".permutations = Iterator(abb, bab, bba)`

151. #### def prefixLength(p: (A) ⇒ Boolean): Int

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     p

       the predicate used to test elements.

     returns

       the length of the longest prefix of this list buffer such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       SeqForwarder → GenSeqLike

152. #### def prepend(elems: A*): Unit

     Prepends given elements to this buffer.

     Prepends given elements to this buffer.

     elems

       the elements to prepend.

     Definition Classes
       BufferLike

153. #### def prependAll(xs: TraversableOnce[A]): Unit

     Prepends the elements contained in a traversable object to this buffer.

     Prepends the elements contained in a traversable object to this buffer.

     xs

       the collection containing the elements to prepend.

     Definition Classes
       BufferLike

154. #### def prependToList(xs: List[A]): List[A]

     Prepends the elements of this buffer to a given list

     Prepends the elements of this buffer to a given list

     xs

       the list to which elements are prepended

155. #### abstract def product: A

     [use case] Multiplies up the elements of this collection.

     [use case]

     Multiplies up the elements of this collection.

     returns

       the product of all elements of this list buffer with respect to the `*` operator in `num`.

     Definition Classes
       GenTraversableOnce

156. #### def product[B >: A](implicit num: Numeric[B]): B

     Multiplies up the elements of this collection.

     Multiplies up the elements of this collection.

     B

       the result type of the `*` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `*` operator to be used in forming the product.

     returns

       the product of all elements of this list buffer with respect to the `*` operator in `num`.

     Definition Classes
       TraversableForwarder → TraversableOnce → GenTraversableOnce

157. #### def readOnly: List[A]

     expose the underlying list but do not mark it as exported

     expose the underlying list but do not mark it as exported

     returns

       A sequence which refers to this buffer for all its operations.

     Definition Classes
       ListBuffer → BufferLike

158. #### def reduce[A1 >: A](op: (A1, A1) ⇒ A1): A1

     Reduces the elements of this list buffer using the specified associative binary operator.

     Reduces the elements of this list buffer using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       The result of applying reduce operator `op` between all the elements if the list buffer is nonempty.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Exceptions thrown
       UnsupportedOperationException

       if this list buffer is empty.

159. #### def reduceLeft[B >: A](op: (B, A) ⇒ B): B

     Definition Classes
       TraversableForwarder → TraversableOnce

160. #### def reduceLeftOption[B >: A](op: (B, A) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this list buffer, going left to right.

     Optionally applies a binary operator to all elements of this list buffer, going left to right.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceLeft(op)` is this list buffer is nonempty, `None` otherwise.

     Definition Classes
       TraversableForwarder → TraversableOnce → GenTraversableOnce

161. #### def reduceOption[A1 >: A](op: (A1, A1) ⇒ A1): Option[A1]

     Reduces the elements of this list buffer, if any, using the specified associative binary operator.

     Reduces the elements of this list buffer, if any, using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

162. #### def reduceRight[B >: A](op: (A, B) ⇒ B): B

     Applies a binary operator to all elements of this list buffer, going right to left.

     Applies a binary operator to all elements of this list buffer, going right to left.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this list buffer, going right to left:

                       op(x,,1,,, op(x,,2,,, ..., op(x,,n-1,,, x,,n,,)...))

       where `x1, ..., xn` are the elements of this list buffer.

     Definition Classes
       TraversableForwarder → TraversableOnce → GenTraversableOnce
     Exceptions thrown
       `UnsupportedOperationException`

       if this list buffer is empty.

163. #### def reduceRightOption[B >: A](op: (A, B) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this list buffer, going right to left.

     Optionally applies a binary operator to all elements of this list buffer, going right to left.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceRight(op)` is this list buffer is nonempty, `None` otherwise.

     Definition Classes
       TraversableForwarder → TraversableOnce → GenTraversableOnce

164. #### def remove(n: Int): A

     Removes the element on a given index position.

     Removes the element on a given index position. May take time linear in the buffer size.

     n

       the index which refers to the element to delete.

     returns

       n the element that was formerly at position `n`.

     Definition Classes
       ListBuffer → BufferLike
     Exceptions thrown
       Predef.IndexOutOfBoundsException

       if `n` is out of bounds.

     Note

       an element must exists at position `n`.

165. #### def remove(n: Int, count: Int): Unit

     Removes a given number of elements on a given index position.

     Removes a given number of elements on a given index position. May take time linear in the buffer size.

     n

       the index which refers to the first element to remove.

     count

       the number of elements to remove.

     Definition Classes
       ListBuffer → BufferLike

166. #### def repr: ListBuffer[A]

     The collection of type list buffer underlying this `TraversableLike` object.

     The collection of type list buffer underlying this `TraversableLike` object. By default this is implemented as the `TraversableLike` object itself, but this can be overridden.

     Definition Classes
       TraversableLike → GenTraversableLike

167. #### def result(): List[A]

     Produces a collection from the added elements.

     Produces a collection from the added elements. The builder's contents are undefined after this operation.

     returns

       a collection containing the elements added to this builder.

     Definition Classes
       ListBuffer → Builder

168. #### def reverse: ListBuffer[A]

     Returns new list buffer wih elements in reversed order.

     Returns new list buffer wih elements in reversed order.

     returns

       A new list buffer with all elements of this list buffer in reversed order.

     Definition Classes
       SeqLike → GenSeqLike

169. #### def reverseIterator: Iterator[A]

     An iterator yielding elements in reversed order.

     An iterator yielding elements in reversed order.

     Note: `xs.reverseIterator` is the same as `xs.reverse.iterator` but might be more efficient.

     returns

       an iterator yielding the elements of this list buffer in reversed order

     Definition Classes
       SeqForwarder → SeqLike

170. #### abstract def reverseMap[B](f: (A) ⇒ B): ListBuffer[B]

     [use case] Builds a new collection by applying a function to all elements of this list buffer and collecting the results in reversed order.

     [use case]

     Builds a new collection by applying a function to all elements of this list buffer and collecting the results in reversed order.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this list buffer and collecting the results in reversed order.

       Note: `xs.reverseMap(f)` is the same as `xs.reverse.map(f)` but might be more efficient.

     Definition Classes
       GenSeqLike

171. #### def reverseMap[B, That](f: (A) ⇒ B)(implicit bf: CanBuildFrom[ListBuffer[A], B, That]): That

     Builds a new collection by applying a function to all elements of this list buffer and collecting the results in reversed order.

     Builds a new collection by applying a function to all elements of this list buffer and collecting the results in reversed order.

     Note: `xs.reverseMap(f)` is the same as `xs.reverse.map(f)` but might be more efficient.

     B

       the element type of the returned collection.

     That

       the class of the returned collection. In the standard library configuration, `That` is always `ListBuffer[B]` because an implicit of type `CanBuildFrom[ListBuffer, B, ListBuffer[B]]` is defined in object `ListBuffer`.

     f

       the function to apply to each element.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ListBuffer`.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this list buffer and collecting the results in reversed order.

     Definition Classes
       SeqLike → GenSeqLike

172. #### def reversed: List[A]

     Attributes
       protected[this]
     Definition Classes
       TraversableOnce

173. #### abstract def sameElements(that: GenIterable[A]): Boolean

     [use case] Checks if the other iterable collection contains the same elements in the same order as this list buffer.

     [use case]

     Checks if the other iterable collection contains the same elements in the same order as this list buffer.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       GenIterableLike

174. #### def sameElements[B >: A](that: GenIterable[B]): Boolean

     Checks if the other iterable collection contains the same elements in the same order as this list buffer.

     Checks if the other iterable collection contains the same elements in the same order as this list buffer.

     B

       the type of the elements of collection `that`.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       IterableForwarder → IterableLike → GenIterableLike

175. #### def scan[B >: A, That](z: B)(op: (B, B) ⇒ B)(implicit cbf: CanBuildFrom[ListBuffer[A], B, That]): That

     Computes a prefix scan of the elements of the collection.

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     B

       element type of the resulting collection

     That

       type of the resulting collection

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     cbf

       combiner factory which provides a combiner

     returns

       a new list buffer containing the prefix scan of the elements in this list buffer

     Definition Classes
       TraversableLike → GenTraversableLike

176. #### def scanLeft[B, That](z: B)(op: (B, A) ⇒ B)(implicit bf: CanBuildFrom[ListBuffer[A], B, That]): That

     Produces a collection containing cummulative results of applying the operator going left to right.

     Produces a collection containing cummulative results of applying the operator going left to right.

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ListBuffer`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike

177. #### def scanRight[B, That](z: B)(op: (A, B) ⇒ B)(implicit bf: CanBuildFrom[ListBuffer[A], B, That]): That

     Produces a collection containing cummulative results of applying the operator going right to left.

     Produces a collection containing cummulative results of applying the operator going right to left. The head of the collection is the last cummulative result.

     Example:

            List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ListBuffer`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) The behavior of `scanRight` has changed. The previous behavior can be reproduced with scanRight.reverse.

178. #### def segmentLength(p: (A) ⇒ Boolean, from: Int): Int

     Computes length of longest segment whose elements all satisfy some predicate.

     Computes length of longest segment whose elements all satisfy some predicate.

     p

       the predicate used to test elements.

     from

       the index where the search starts.

     returns

       the length of the longest segment of this list buffer starting from index `from` such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       SeqForwarder → SeqLike → GenSeqLike

179. #### def seq: Seq[A]

     A version of this collection with all of the operations implemented sequentially (i.

     A version of this collection with all of the operations implemented sequentially (i.e. in a single-threaded manner).

     This method returns a reference to this collection. In parallel collections, it is redefined to return a sequential implementation of this collection. In both cases, it has O(1) complexity.

     returns

       a sequential view of the collection.

     Definition Classes
       Seq → Seq → GenSeq → Iterable → Iterable → GenIterable → Traversable → Traversable → GenTraversable → Parallelizable → TraversableOnce → GenTraversableOnce

180. #### def size: Int

     The size of this list buffer.

     The size of this list buffer.

     returns

       the number of elements in this list buffer.

     Definition Classes
       TraversableForwarder → GenTraversableLike → TraversableOnce → GenTraversableOnce

181. #### def sizeHint(coll: scala.collection.TraversableLike[_, _], delta: Int = 0): Unit

     Gives a hint that one expects the `result` of this builder to have the same size as the given collection, plus some delta.

     Gives a hint that one expects the `result` of this builder to have the same size as the given collection, plus some delta. This will provide a hint only if the collection is known to have a cheap `size` method. Currently this is assumed to be the case if and only if the collection is of type `IndexedSeqLike`. Some builder classes will optimize their representation based on the hint. However, builder implementations are still required to work correctly even if the hint is wrong, i.e. a different number of elements is added.

     coll

       the collection which serves as a hint for the result's size.

     delta

       a correction to add to the `coll.size` to produce the size hint.

     Definition Classes
       Builder

182. #### def sizeHint(size: Int): Unit

     Gives a hint how many elements are expected to be added when the next `result` is called.

     Gives a hint how many elements are expected to be added when the next `result` is called. Some builder classes will optimize their representation based on the hint. However, builder implementations are still required to work correctly even if the hint is wrong, i.e. a different number of elements is added.

     size

       the hint how many elements will be added.

     Definition Classes
       Builder

183. #### def sizeHintBounded(size: Int, boundingColl: scala.collection.TraversableLike[_, _]): Unit

     Gives a hint how many elements are expected to be added when the next `result` is called, together with an upper bound given by the size of some other collection.

     Gives a hint how many elements are expected to be added when the next `result` is called, together with an upper bound given by the size of some other collection. Some builder classes will optimize their representation based on the hint. However, builder implementations are still required to work correctly even if the hint is wrong, i.e. a different number of elements is added.

     size

       the hint how many elements will be added.

     boundingColl

       the bounding collection. If it is an IndexedSeqLike, then sizes larger than collection's size are reduced.

     Definition Classes
       Builder

184. #### def slice(from: Int, until: Int): ListBuffer[A]

     Selects an interval of elements.

     Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

            from <= indexOf(x) < until

     from

       the lowest index to include from this list buffer.

     until

       the highest index to EXCLUDE from this list buffer.

     returns

       a list buffer containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this list buffer.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

185. #### def sliding[B >: A](size: Int, step: Int): Iterator[ListBuffer[A]]

     Definition Classes
       IterableLike

186. #### def sliding[B >: A](size: Int): Iterator[ListBuffer[A]]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     size

       the number of elements per group

     returns

       An iterator producing list buffers of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       Iterator#sliding

187. #### def sortBy[B](f: (A) ⇒ B)(implicit ord: Ordering[B]): ListBuffer[A]

     Sorts this ListBuffer according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     Sorts this ListBuffer according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     B

       the target type of the transformation `f`, and the type where the ordering `ord` is defined.

     f

       the transformation function mapping elements to some other domain `B`.

     ord

       the ordering assumed on domain `B`.

     returns

       a list buffer consisting of the elements of this list buffer sorted according to the ordering where `x < y` if `ord.lt(f(x), f(y))`.

     Definition Classes
       SeqLike
     Example:

     1.        val words = "The quick brown fox jumped over the lazy dog".split(' ')
               // this works because scala.Ordering will implicitly provide an Ordering[Tuple2[Int, Char]]
               words.sortBy(x => (x.length, x.head))
               res0: Array[String] = Array(The, dog, fox, the, lazy, over, brown, quick, jumped)

     See also

       scala.math.Ordering

188. #### def sortWith(lt: (A, A) ⇒ Boolean): ListBuffer[A]

     Sorts this list buffer according to a comparison function.

     Sorts this list buffer according to a comparison function.

     The sort is stable. That is, elements that are equal wrt `lt` appear in the same order in the sorted sequence as in the original.

     lt

       the comparison function which tests whether its first argument precedes its second argument in the desired ordering.

     returns

       a list buffer consisting of the elements of this list buffer sorted according to the comparison function `lt`.

     Definition Classes
       SeqLike
     Example:

     1.        List("Steve", "Tom", "John", "Bob").sortWith(_.compareTo(_) < 0) =
               List("Bob", "John", "Steve", "Tom")

189. #### def sorted[B >: A](implicit ord: Ordering[B]): ListBuffer[A]

     Sorts this list buffer according to an Ordering.

     Sorts this list buffer according to an Ordering.

     The sort is stable. That is, elements that are equal wrt `lt` appear in the same order in the sorted sequence as in the original.

     ord

       the ordering to be used to compare elements.

     returns

       a list buffer consisting of the elements of this list buffer sorted according to the ordering `ord`.

     Definition Classes
       SeqLike
     See also

       scala.math.Ordering

190. #### def span(p: (A) ⇒ Boolean): (ListBuffer[A], ListBuffer[A])

     Splits this list buffer into a prefix/suffix pair according to a predicate.

     Splits this list buffer into a prefix/suffix pair according to a predicate.

     Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

     p

       the test predicate

     returns

       a pair consisting of the longest prefix of this list buffer whose elements all satisfy `p`, and the rest of this list buffer.

     Definition Classes
       TraversableLike → GenTraversableLike

191. #### def splitAt(n: Int): (ListBuffer[A], ListBuffer[A])

     Splits this list buffer into two at a given position.

     Splits this list buffer into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     n

       the position at which to split.

     returns

       a pair of list buffers consisting of the first `n` elements of this list buffer, and the other elements.

     Definition Classes
       TraversableLike → GenTraversableLike

192. #### def startsWith[B](that: GenSeq[B]): Boolean

     Tests whether this list buffer starts with the given sequence.

     Tests whether this list buffer starts with the given sequence.

     that

       the sequence to test

     returns

       `true` if this collection has `that` as a prefix, `false` otherwise.

     Definition Classes
       SeqForwarder → GenSeqLike

193. #### def startsWith[B](that: GenSeq[B], offset: Int): Boolean

     Tests whether this list buffer contains the given sequence at a given index.

     Tests whether this list buffer contains the given sequence at a given index.

     If the both the receiver object, `this` and the argument, `that` are infinite sequences this method may not terminate.

     that

       the sequence to test

     offset

       the index where the sequence is searched.

     returns

       `true` if the sequence `that` is contained in this list buffer at index `offset`, otherwise `false`.

     Definition Classes
       SeqForwarder → SeqLike → GenSeqLike

194. #### def stringPrefix: String

     Defines the prefix of the string representation.

     Defines the prefix of the string representation.

     returns

       the string representation of this buffer.

     Definition Classes
       ListBuffer → BufferLike → TraversableLike → GenTraversableLike

195. #### abstract def sum: A

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements of this list buffer with respect to the `+` operator in `num`.

     Definition Classes
       GenTraversableOnce

196. #### def sum[B >: A](implicit num: Numeric[B]): B

     Sums up the elements of this collection.

     Sums up the elements of this collection.

     B

       the result type of the `+` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `+` operator to be used in forming the sum.

     returns

       the sum of all elements of this list buffer with respect to the `+` operator in `num`.

     Definition Classes
       TraversableForwarder → TraversableOnce → GenTraversableOnce

197. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

198. #### def tail: ListBuffer[A]

     Selects all elements except the first.

     Selects all elements except the first.

     returns

       a list buffer consisting of all elements of this list buffer except the first one.

     Definition Classes
       TraversableLike → GenTraversableLike
     Exceptions thrown
       `UnsupportedOperationException`

       if the list buffer is empty.

199. #### def tails: Iterator[ListBuffer[A]]

     Iterates over the tails of this list buffer.

     Iterates over the tails of this list buffer. The first value will be this list buffer and the final one will be an empty list buffer, with the intervening values the results of successive applications of `tail`.

     returns

       an iterator over all the tails of this list buffer

     Definition Classes
       TraversableLike
     Example:

     1. `List(1,2,3).tails = Iterator(List(1,2,3), List(2,3), List(3), Nil)`

200. #### def take(n: Int): ListBuffer[A]

     Selects first n elements.

     Selects first n elements.

     n

       Tt number of elements to take from this list buffer.

     returns

       a list buffer consisting only of the first `n` elements of this list buffer, or else the whole list buffer, if it has less than `n` elements.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

201. #### def takeRight(n: Int): ListBuffer[A]

     Selects last n elements.

     Selects last n elements.

     n

       the number of elements to take

     returns

       a list buffer consisting only of the last `n` elements of this list buffer, or else the whole list buffer, if it has less than `n` elements.

     Definition Classes
       IterableLike

202. #### def takeWhile(p: (A) ⇒ Boolean): ListBuffer[A]

     Takes longest prefix of elements that satisfy a predicate.

     Takes longest prefix of elements that satisfy a predicate.

     p

       The predicate used to test elements.

     returns

       the longest prefix of this list buffer whose elements all satisfy the predicate `p`.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

203. #### def thisCollection: Seq[A]

     The underlying collection seen as an instance of `ListBuffer`.

     The underlying collection seen as an instance of `ListBuffer`. By default this is implemented as the current collection object itself, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       SeqLike → IterableLike → TraversableLike

204. #### abstract def toArray: Array[A]

     [use case] Converts this list buffer to an array.

     [use case]

     Converts this list buffer to an array.

     returns

       an array containing all elements of this list buffer.

     Definition Classes
       GenTraversableOnce

205. #### def toArray[B >: A](implicit arg0: ClassManifest[B]): Array[B]

     Converts this list buffer to an array.

     Converts this list buffer to an array.

     B

       the type of the elements of the array. A `ClassManifest` for this type must be available.

     returns

       an array containing all elements of this list buffer.

     Definition Classes
       TraversableForwarder → TraversableOnce → GenTraversableOnce

206. #### def toBuffer[B >: A]: Buffer[B]

     Converts this list buffer to a mutable buffer.

     Converts this list buffer to a mutable buffer.

     returns

       a buffer containing all elements of this list buffer.

     Definition Classes
       TraversableForwarder → TraversableOnce → GenTraversableOnce

207. #### def toCollection(repr: ListBuffer[A]): Seq[A]

     A conversion from collections of type `Repr` to `ListBuffer` objects.

     A conversion from collections of type `Repr` to `ListBuffer` objects. By default this is implemented as just a cast, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       SeqLike → IterableLike → TraversableLike

208. #### def toIndexedSeq[B >: A]: IndexedSeq[A]

     Converts this list buffer to an indexed sequence.

     Converts this list buffer to an indexed sequence.

     returns

       an indexed sequence containing all elements of this list buffer.

     Definition Classes
       TraversableForwarder → TraversableOnce → GenTraversableOnce

209. #### def toIterable: Iterable[A]

     Converts this list buffer to an iterable collection.

     Converts this list buffer to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     returns

       an `Iterable` containing all elements of this list buffer.

     Definition Classes
       TraversableForwarder → TraversableOnce → GenTraversableOnce

210. #### def toIterator: Iterator[A]

     Returns an Iterator over the elements in this list buffer.

     Returns an Iterator over the elements in this list buffer. Will return the same Iterator if this instance is already an Iterator.

     returns

       an Iterator containing all elements of this list buffer.

     Definition Classes
       TraversableLike → GenTraversableOnce

211. #### def toList: List[A]

     Converts this buffer to a list.

     Converts this buffer to a list. Takes constant time. The buffer is copied lazily, the first time it is mutated.

     returns

       a list containing all elements of this list buffer.

     Definition Classes
       ListBuffer → TraversableForwarder → TraversableOnce → GenTraversableOnce

212. #### abstract def toMap[T, U]: Map[T, U]

     [use case] Converts this list buffer to a map.

     [use case]

     Converts this list buffer to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map containing all elements of this list buffer.

     Definition Classes
       GenTraversableOnce

213. #### def toMap[T, U](implicit ev: <:<[A, (T, U)]): Map[T, U]

     Converts this list buffer to a map.

     Converts this list buffer to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map containing all elements of this list buffer.

     Definition Classes
       TraversableForwarder → TraversableOnce → GenTraversableOnce

214. #### def toSeq: Seq[A]

     Converts this list buffer to a sequence.

     Converts this list buffer to a sequence. As with `toIterable`, it's lazy in this default implementation, as this `TraversableOnce` may be lazy and unevaluated.

     returns

       a sequence containing all elements of this list buffer.

     Definition Classes
       TraversableForwarder → TraversableOnce → GenTraversableOnce

215. #### def toSet[B >: A]: Set[B]

     Converts this list buffer to a set.

     Converts this list buffer to a set.

     returns

       a set containing all elements of this list buffer.

     Definition Classes
       TraversableForwarder → TraversableOnce → GenTraversableOnce

216. #### def toStream: Stream[A]

     Converts this list buffer to a stream.

     Converts this list buffer to a stream.

     returns

       a stream containing all elements of this list buffer.

     Definition Classes
       TraversableForwarder → TraversableLike → GenTraversableOnce

217. #### def toString(): String

     Converts this list buffer to a string.

     Converts this list buffer to a string.

     returns

       a string representation of this collection. By default this string consists of the `stringPrefix` of this list buffer, followed by all elements separated by commas and enclosed in parentheses.

     Definition Classes
       SeqLike → TraversableLike → AnyRef → Any

218. #### def toTraversable: Traversable[A]

     Converts this list buffer to an unspecified Traversable.

     Converts this list buffer to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     returns

       a Traversable containing all elements of this list buffer.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce

219. #### def transform(f: (A) ⇒ A): ListBuffer.this.type

     Applies a transformation function to all values contained in this sequence.

     Applies a transformation function to all values contained in this sequence. The transformation function produces new values from existing elements.

     f

       the transformation to apply

     returns

       the sequence itself.

     Definition Classes
       SeqLike

220. #### def transpose[B](implicit asTraversable: (A) ⇒ GenTraversableOnce[B]): ListBuffer[ListBuffer[B]]

     Transposes this list buffer of traversable collections into a list buffer of list buffers.

     Transposes this list buffer of traversable collections into a list buffer of list buffers.

     B

       the type of the elements of each traversable collection.

     asTraversable

       an implicit conversion which asserts that the element type of this list buffer is a `Traversable`.

     returns

       a two-dimensional list buffer of list buffers which has as nth row the nth column of this list buffer.

     Definition Classes
       GenericTraversableTemplate
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

     Exceptions thrown
       `IllegalArgumentException`

       if all collections in this list buffer are not of the same size.

221. #### def trimEnd(n: Int): Unit

     Removes the last n elements of this buffer.

     Removes the last n elements of this buffer.

     n

       the number of elements to remove from the end of this buffer.

     Definition Classes
       BufferLike

222. #### def trimStart(n: Int): Unit

     Removes the first n elements of this buffer.

     Removes the first n elements of this buffer.

     n

       the number of elements to remove from the beginning of this buffer.

     Definition Classes
       BufferLike

223. #### def underlying: Seq[A]

     The iterable object to which calls are forwarded

     The iterable object to which calls are forwarded

     Attributes
       protected
     Definition Classes
       ListBuffer → SeqForwarder → IterableForwarder → TraversableForwarder

224. #### abstract def union(that: Seq[A]): ListBuffer[A]

     [use case] Produces a new sequence which contains all elements of this list buffer and also all elements of a given sequence.

     [use case]

     Produces a new sequence which contains all elements of this list buffer and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

     that

       the sequence to add.

     returns

       a new collection of type `That` which contains all elements of this list buffer followed by all elements of `that`.

     Definition Classes
       SeqLike

225. #### def union[B >: A, That](that: GenSeq[B])(implicit bf: CanBuildFrom[ListBuffer[A], B, That]): That

     Produces a new sequence which contains all elements of this list buffer and also all elements of a given sequence.

     Produces a new sequence which contains all elements of this list buffer and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

     Another way to express this is that `xs union ys` computes the order-presevring multi-set union of `xs` and `ys`. `union` is hence a counter-part of `diff` and `intersect` which also work on multi-sets.

     B

       the element type of the returned list buffer.

     That

       the class of the returned collection. In the standard library configuration, `That` is always `ListBuffer[B]` because an implicit of type `CanBuildFrom[ListBuffer, B, ListBuffer[B]]` is defined in object `ListBuffer`.

     that

       the sequence to add.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ListBuffer`.

     returns

       a new collection of type `That` which contains all elements of this list buffer followed by all elements of `that`.

     Definition Classes
       SeqLike → GenSeqLike

226. #### def unzip[A1, A2](implicit asPair: (A) ⇒ (A1, A2)): (ListBuffer[A1], ListBuffer[A2])

     Converts this list buffer of pairs into two collections of the first and second half of each pair.

     Converts this list buffer of pairs into two collections of the first and second half of each pair.

     asPair

       an implicit conversion which asserts that the element type of this list buffer is a pair.

     returns

       a pair list buffers, containing the first, respectively second half of each element pair of this list buffer.

     Definition Classes
       GenericTraversableTemplate

227. #### def unzip3[A1, A2, A3](implicit asTriple: (A) ⇒ (A1, A2, A3)): (ListBuffer[A1], ListBuffer[A2], ListBuffer[A3])

     Converts this list buffer of triples into three collections of the first, second, and third element of each triple.

     Converts this list buffer of triples into three collections of the first, second, and third element of each triple.

     asTriple

       an implicit conversion which asserts that the element type of this list buffer is a triple.

     returns

       a triple list buffers, containing the first, second, respectively third member of each element triple of this list buffer.

     Definition Classes
       GenericTraversableTemplate

228. #### def update(n: Int, x: A): Unit

     Replaces element at index `n` with the new element `newelem`.

     Replaces element at index `n` with the new element `newelem`. Takes time linear in the buffer size. (except the first element, which is updated in constant time).

     n

       the index of the element to replace.

     x

       the new element.

     Definition Classes
       ListBuffer → BufferLike → SeqLike
     Exceptions thrown
       Predef.IndexOutOfBoundsException

       if `n` is out of bounds.

229. #### abstract def updated(index: Int, elem: A): ListBuffer[A]

     [use case] A copy of this list buffer with one single replaced element.

     [use case]

     A copy of this list buffer with one single replaced element.

     index

       the position of the replacement

     elem

       the replacing element

     returns

       a new list buffer`which is a copy of this list buffer with the element at position` index`replaced by` elem`.`

     Definition Classes
       GenSeqLike

230. #### def updated[B >: A, That](index: Int, elem: B)(implicit bf: CanBuildFrom[ListBuffer[A], B, That]): That

     A copy of this list buffer with one single replaced element.

     A copy of this list buffer with one single replaced element.

     B

       the element type of the returned list buffer.

     That

       the class of the returned collection. In the standard library configuration, `That` is always `ListBuffer[B]` because an implicit of type `CanBuildFrom[ListBuffer, B, ListBuffer[B]]` is defined in object `ListBuffer`.

     index

       the position of the replacement

     elem

       the replacing element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ListBuffer`.

     returns

       a new list buffer`which is a copy of this list buffer with the element at position` index`replaced by` elem`.`

     Definition Classes
       SeqLike → GenSeqLike

231. #### def view(from: Int, until: Int): SeqView[A, ListBuffer[A]]

     Creates a non-strict view of a slice of this list buffer.

     Creates a non-strict view of a slice of this list buffer.

     Note: the difference between `view` and `slice` is that `view` produces a view of the current list buffer, whereas `slice` produces a new list buffer.

     Note: `view(from, to)` is equivalent to `view.slice(from, to)`

     from

       the index of the first element of the view

     until

       the index of the element following the view

     returns

       a non-strict view of a slice of this list buffer, starting at index `from` and extending up to (but not including) index `until`.

     Definition Classes
       SeqLike → IterableLike → TraversableLike

232. #### def view: SeqView[A, ListBuffer[A]]

     Creates a non-strict view of this list buffer.

     Creates a non-strict view of this list buffer.

     returns

       a non-strict view of this list buffer.

     Definition Classes
       SeqLike → IterableLike → TraversableLike

233. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

234. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

235. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

236. #### def withFilter(p: (A) ⇒ Boolean): FilterMonadic[A, ListBuffer[A]]

     Creates a non-strict filter of this list buffer.

     Creates a non-strict filter of this list buffer.

     Note: the difference between `c filter p` and `c withFilter p` is that the former creates a new collection, whereas the latter only restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

     p

       the predicate used to test elements.

     returns

       an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this list buffer which satisfy the predicate `p`.

     Definition Classes
       TraversableLike → FilterMonadic

237. #### abstract def zip[B](that: GenIterable[B]): ListBuffer[(A, B)]

     [use case] Returns a list buffer formed from this list buffer and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a list buffer formed from this list buffer and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this list buffer and `that`. The length of the returned collection is the minimum of the lengths of this list buffer and `that`.

     Definition Classes
       GenIterableLike

238. #### def zip[A1 >: A, B, That](that: GenIterable[B])(implicit bf: CanBuildFrom[ListBuffer[A], (A1, B), That]): That

     Returns a list buffer formed from this list buffer and another iterable collection by combining corresponding elements in pairs.

     Returns a list buffer formed from this list buffer and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     A1

       the type of the first half of the returned pairs (this is always a supertype of the collection's element type `A`).

     B

       the type of the second half of the returned pairs

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, B)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, B), That]`. is found.

     that

       The iterable providing the second half of each result pair

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `(A1, B)`.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this list buffer and `that`. The length of the returned collection is the minimum of the lengths of this list buffer and `that`.

     Definition Classes
       IterableLike → GenIterableLike

239. #### abstract def zipAll[B](that: Iterable[B], thisElem: A, thatElem: B): ListBuffer[(A, B)]

     [use case] Returns a list buffer formed from this list buffer and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a list buffer formed from this list buffer and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this list buffer is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this list buffer.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this list buffer and `that`. The length of the returned collection is the maximum of the lengths of this list buffer and `that`. If this list buffer is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this list buffer, `thatElem` values are used to pad the result.

     Definition Classes
       GenIterableLike

240. #### def zipAll[B, A1 >: A, That](that: GenIterable[B], thisElem: A1, thatElem: B)(implicit bf: CanBuildFrom[ListBuffer[A], (A1, B), That]): That

     Returns a list buffer formed from this list buffer and another iterable collection by combining corresponding elements in pairs.

     Returns a list buffer formed from this list buffer and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this list buffer is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this list buffer.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this list buffer and `that`. The length of the returned collection is the maximum of the lengths of this list buffer and `that`. If this list buffer is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this list buffer, `thatElem` values are used to pad the result.

     Definition Classes
       IterableLike → GenIterableLike

241. #### abstract def zipWithIndex: ListBuffer[(A, Int)]

     [use case] Zips this list buffer with its indices.

     [use case]

     Zips this list buffer with its indices.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this list buffer paired with their index. Indices start at `0`.

     Definition Classes
       GenIterableLike

242. #### def zipWithIndex[A1 >: A, That](implicit bf: CanBuildFrom[ListBuffer[A], (A1, Int), That]): That

     Zips this list buffer with its indices.

     Zips this list buffer with its indices.

     A1

       the type of the first half of the returned pairs (this is always a supertype of the collection's element type `A`).

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, Int)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, Int), That]`. is found.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this list buffer paired with their index. Indices start at `0`.

     Definition Classes
       IterableLike → GenIterableLike

### Deprecated Value Members

1. #### def +(elem1: A, elem2: A, elems: A*): ListBuffer[A]

   Adds two or more elements to this collection and returns the collection itself.

   Adds two or more elements to this collection and returns the collection itself.

   Note that for backward compatibility reasons, this method mutates the collection in place, unlike similar but undeprecated methods throughout the collections hierarchy. You are strongly recommended to use '++=' instead.

   elem1

     the first element to add.

   elem2

     the second element to add.

   elems

     the remaining elements to add.

   Definition Classes
     BufferLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) "Use ++= instead if you intend to add by side effect to an existing collection.\012".+("Use `clone() ++=\' if you intend to create a new collection.")`

2. #### def +(elem: A): ListBuffer[A]

   Adds a single element to this collection and returns the collection itself.

   Adds a single element to this collection and returns the collection itself.

   Note that for backward compatibility reasons, this method mutates the collection in place, unlike similar but undeprecated methods throughout the collections hierarchy. You are strongly recommended to use '+=' instead.

   elem

     the element to add.

   Definition Classes
     BufferLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) "Use += instead if you intend to add by side effect to an existing collection.\012".+("Use `clone() +=\' if you intend to create a new collection.")`

3. #### def ++=(src: Array[A], start: Int, len: Int): Unit

   Adds a number of elements in an array

   Adds a number of elements in an array

   src

     the array

   start

     the first element to append

   len

     the number of elements to append

   Definition Classes
     BufferLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) replace by: `buf ++= src.view(start, end)`

4. #### def elements: Iterator[A]

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `iterator' instead`

5. #### def equalsWith[B](that: Seq[B])(f: (A, B) ⇒ Boolean): Boolean

   Tests whether every element of this list buffer relates to the corresponding element of another sequence by satisfying a test predicate.

   Tests whether every element of this list buffer relates to the corresponding element of another sequence by satisfying a test predicate.

   B

     the type of the elements of `that`

   that

     the other sequence

   returns

     `true` if both sequences have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this list buffer and `y` of `that`, otherwise `false`.

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `corresponds` instead

6. #### def findLastIndexOf(p: (A) ⇒ Boolean): Int

   Returns index of the last element satisfying a predicate, or -1.

   Returns index of the last element satisfying a predicate, or -1.

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `lastIndexWhere` instead

7. #### def first: A

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `head' instead`

8. #### def firstOption: Option[A]

   `None` if iterable is empty.

   `None` if iterable is empty.

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `headOption' instead`

9. #### def projection: SeqView[A, ListBuffer[A]]

   returns a projection that can be used to call non-strict `filter`, `map`, and `flatMap` methods that build projections of the collection.

   returns a projection that can be used to call non-strict `filter`, `map`, and `flatMap` methods that build projections of the collection.

   Definition Classes
     SeqLike → IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `view' instead`

10. #### def reversedElements: Iterator[A]

    Definition Classes
      SeqLike
    Annotations
      @deprecated
    Deprecated

      (Since version 2.8.0) use `reverseIterator' instead`

### Inherited from Serializable

### Inherited from SeqForwarder[A]

### Inherited from IterableForwarder[A]

### Inherited from TraversableForwarder[A]

### Inherited from Builder[A, List[A]]

### Inherited from Buffer[A]

### Inherited from BufferLike[A, ListBuffer[A]]

### Inherited from Subtractable[A, ListBuffer[A]]

### Inherited from Scriptable[A]

### Inherited from Shrinkable[A]

### Inherited from Growable[A]

### Inherited from Seq[A]

### Inherited from SeqLike[A, ListBuffer[A]]

### Inherited from Cloneable[ListBuffer[A]]

### Inherited from Seq[A]

### Inherited from SeqLike[A, ListBuffer[A]]

### Inherited from GenSeq[A]

### Inherited from GenSeqLike[A, ListBuffer[A]]

### Inherited from PartialFunction[Int, A]

### Inherited from (Int) ⇒ A

### Inherited from Iterable[A]

### Inherited from IterableLike[A, ListBuffer[A]]

### Inherited from Equals

### Inherited from GenIterable[A]

### Inherited from GenIterableLike[A, ListBuffer[A]]

### Inherited from Traversable[A]

### Inherited from Mutable

### Inherited from Traversable[A]

### Inherited from GenTraversable[A]

### Inherited from GenericTraversableTemplate[A, ListBuffer]

### Inherited from TraversableLike[A, ListBuffer[A]]

### Inherited from GenTraversableLike[A, ListBuffer[A]]

### Inherited from Parallelizable[A, ParSeq[A]]

### Inherited from TraversableOnce[A]

### Inherited from GenTraversableOnce[A]

### Inherited from FilterMonadic[A, ListBuffer[A]]

### Inherited from HasNewBuilder[A, ListBuffer[A]]

### Inherited from AnyRef

### Inherited from Any